/***********************************/
// GET anniversaryDB FROM HOMEPAGE
/***********************************/

var gInfoButton, gDoneButton;
var gFrontHeight, gFrontWidth, gFront;

function setup()
{
	if (window.widget)	// always check to make sure that you are running in Dashboard
	{
		createGenericButton(document.getElementById("regetButton"),"再取得",regetword);
		createGenericButton(document.getElementById("doneButton"),"完了",hidePrefs);
		gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs);
	gFront = true;

		widget.onshow = onshow;
		widget.onhide = onhide;
		widget.onremove = onremove;

		regetword()
	}
}

function onshow()
{
	gFrontHeight = widget.preferenceForKey("tempHeight");
	gFrontWidth = widget.preferenceForKey("tempWidth");

	if (gFront && gFrontHeight && gFrontWidth)
	{
		var wHeight = window.innerHeight;
		var wWidth = window.innerWidth;
		if (wHeight != gFrontHeight || wWidth != gFrontWidth)
		{
			var tid = setTimeout(flipToFront(),3000);
			clearTimeout(tid);
		}
	}

	date = new Date();
	var year = date.getYear()+1900;
	var month = date.getMonth()+1;
	var day = date.getDate();
	var dow = date.getDay();

	var tempDay = widget.preferenceForKey("tempDay");
	var tempMonth = widget.preferenceForKey("tempMonth");

	if (tempDay && tempMonth)
	{
		if (day != tempDay || month != tempMonth)
		{
			document.getElementById("debug").innerText = "diff. day";
			setword(year,month,day,dow,false);
		} else {
			document.getElementById("debug").innerText = "same day";
		}
	} else {
		document.getElementById("debug").innerText = "null";
		setword(year,month,day,dow,false);
	}
}


function onhide()
{
	if (gFront)
	{
		widget.setPreferenceForKey(window.innerHeight,"tempHeight");
		widget.setPreferenceForKey(window.innerWidth,"tempWidth");
	}
}

function onremove()
{
	widget.setPreferenceForKey(null,"tempDay");
	widget.setPreferenceForKey(null,"tempMonth");
	widget.setPreferenceForKey(null,"tempHeight");
	widget.setPreferenceForKey(null,"tempWidth");
}

function setword(year,month,day,dow,modf)
{
	document.getElementById("anivdbTemp").innerHTML = loadHTML("http://homepage2.nifty.com/GREIF/database/anniversaryDB/"+String(month)+".html",modf);
	var st_array = document.getElementById("anivdbTemp").innerHTML.split(";")
	var st = st_array[(day-1)*3];
	if (st_array[(day-1)*3+1] != "") st = st + "<br>" + st_array[(day-1)*3+1];
	if (st_array[(day-1)*3+2] != "") st = st + "<br>" + st_array[(day-1)*3+2];

	document.getElementById("anivdbTemp").innerHTML = loadHTML("http://homepage2.nifty.com/GREIF/database/anniversaryDB/"+String(month)+"mn.html",modf);
	var st_array = document.getElementById("anivdbTemp").innerHTML.split(";");
	var st2 = st_array[getDOWitem(year,month,day,dow)];
	if (st2 != "") st = st + "<br>" + st2;

	document.getElementById("anivdbTemp").innerHTML = loadHTML("http://homepage2.nifty.com/GREIF/database/anniversaryDB/0.html",modf);
	st_array = document.getElementById("anivdbTemp").innerHTML.split(";");
	if (st_array[(day-1)] != "") st = st + "<br>" + st_array[(day-1)] + "（毎月"+day+"日）";

	if (st == "") st = "（なし）";

	document.getElementById("anivdb").innerHTML = st;
	document.getElementById("anivdb").style.display = "block";

	widget.setPreferenceForKey(day,"tempDay");
	widget.setPreferenceForKey(month,"tempMonth");
}

function regetword()
{
	date = new Date();
	var year = date.getYear()+1900;
	var month = date.getMonth()+1;
	var day = date.getDate();
	var dow = date.getDay();

	setword(year,month,day,dow,true);
	//document.getElementById("debug").innerText = "reget";
}

function loadHTML(url,modf)
{
	req = new XMLHttpRequest();
	req.open('GET',url,false);
	if (modf) req.setRequestHeader("If-Modified-Since","Sat, 01 Jan 2005 00:00:00 GMT");
	req.send(null);
	return req.responseText;
}

function openWeb(uri)
{
	if (window.widget)
	{
		widget.openURL(uri);
	}
}

function getDOWitem(year,month,day,dow)
{
	date = new Date(String(year)+"/"+String(month)+"/1");
	var dow1 = date.getDay();
	if (dow < dow1)
	{
		return (day-1)+dow1-7;
	} else {
		return (day-1)+dow1;
	}
}

function showReadme()
{
	widget.system("/usr/bin/open Kyoka.rtf",null);
}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/
function showPrefs()
{
	// store the front height and width values to restore on return to front
	gFrontHeight = window.innerHeight;
	gFrontWidth = window.innerWidth;
	gFront = false;

	widget.setPreferenceForKey(window.innerHeight,"tempHeight");
	widget.setPreferenceForKey(window.innerWidth,"tempWidth");

// Two AppleRect objects store the starting and finshing rectangle sizes
	var startingRect = new AppleRect (0, 0, window.innerWidth, window.innerHeight);
	var finishingRect = new AppleRect (0, 0, 240, 143);
	
	// The RectAnimation specifies the range of values and the handler to call at the animator's interval
	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );

	// The Animator is the timer for the animation
	var currentAnimator = new AppleAnimator (500, 13);
	
	// Associate the animator and animation
	currentAnimator.addAnimation(currentRectAnimation);
	
	// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
	currentAnimator.oncomplete = flipToBack;
	
	// Once everything is set up, start the animation
	currentAnimator.start();
}

function flipToBack()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
 
	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}

	front.style.display="none";
	back.style.display="block";

	if (window.widget){
		setTimeout ('widget.performTransition();', 0);
		widget.setCloseBoxOffset(13,14);
	}
}

// The rectHandler is called each interval by the Animator.  It passes in the animation values at
// this point in the animation.  The values are used to resize parts of the interface and the
// widget as a whole

function rectHandler( rectAnimation, currentRect, startingRect, finishingRect )
{
	document.getElementById("middle").style.height = (currentRect.bottom-40);
	document.getElementById("bottom").style.top = (currentRect.bottom-13);
	window.resizeTo(currentRect.right, currentRect.bottom);
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}

	back.style.display="none";
	front.style.display="block";
	
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
		widget.setCloseBoxOffset(7,9);
	}
	
	// Once the flip to the front is complete, flipToFront resizes the widget back to its former size.
	setTimeout("flipToFront()", 750);
	gFront = true;
}

// flipToFront uses another AppleRectAnimation to resize the widget to its previous size

function flipToFront()
{
	var startingRect = new AppleRect (0, 0, 240, 143);
	var finishingRect = new AppleRect (0, 0, gFrontWidth, gFrontHeight);

	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );

	var currentAnimator = new AppleAnimator (500, 13);
	currentAnimator.addAnimation(currentRectAnimation);
	currentAnimator.start();	
}

// Standard widget resize code follows...

var growboxInset;
 
function mouseDown(event)
{
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);

 growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};

	event.stopPropagation();
	event.preventDefault();
}
 
function mouseMove(event)
{
	// checks if the reported event data is legit or not
	if((event.x == -1 ) ) { break; }

	var x = event.x + growboxInset.x;
	var y = event.y + growboxInset.y;
 
	if(x < 240) 	// an arbitrary minimum width
		x = 240;

	if(y < 143)		// an arbitrary minimum height
		y = 143;

	document.getElementById("middle").style.height = (y-40);
	document.getElementById("bottom").style.top = (y-13);
	window.resizeTo(x,y);

	event.stopPropagation();
	event.preventDefault();
}
 
function mouseUp(event)
{
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);

	event.stopPropagation();
	event.preventDefault();
}
